export declare function createExample(): {
    schema: {
        Page: import("alinea/core").Type<{
            [x: string]: any;
        }>;
        Container: import("alinea/core").Type<{
            title: import("../../input/text").TextField;
            path: import("../../input/path").PathField;
            name: import("../../input/text").TextField;
        }>;
    };
    workspaces: {
        main: import("alinea/core").Workspace<{
            pages: import("alinea/core").Root<{
                entry1: import("alinea/core").PageSeed<{
                    [x: string]: any;
                }, Record<string, any>>;
                entry2: import("alinea/core").PageSeed<{
                    title: import("../../input/text").TextField;
                    path: import("../../input/path").PathField;
                    name: import("../../input/text").TextField;
                }, {
                    entry3: any;
                }>;
            }>;
            multiLanguage: import("alinea/core").Root<{
                localised1: import("alinea/core").PageSeed<{
                    [x: string]: any;
                }, Record<string, any>>;
                localised2: import("alinea/core").PageSeed<{
                    title: import("../../input/text").TextField;
                    path: import("../../input/path").PathField;
                    name: import("../../input/text").TextField;
                }, {
                    localised3: any;
                }>;
            }>;
            media: import("../../core/media/MediaRoot").MediaRoot<{
                dir: import("alinea/core").PageSeed<{
                    title: import("../../input/text").TextField;
                    path: import("../../input/path").PathField;
                }, Record<string, any>>;
                'file1.png': import("alinea/core").PageSeed<{
                    title: import("../../input/text").TextField;
                    path: import("../../input/path").PathField;
                    location: import("../../input/hidden").HiddenField<string>;
                    extension: import("../../input/hidden").HiddenField<string>;
                    size: import("../../input/hidden").HiddenField<number>;
                    hash: import("../../input/hidden").HiddenField<string>;
                    width: import("../../input/hidden").HiddenField<number>;
                    height: import("../../input/hidden").HiddenField<number>;
                    preview: import("../../input/hidden").HiddenField<string>;
                    averageColor: import("../../input/hidden").HiddenField<string>;
                    focus: import("../../input/hidden").HiddenField<{
                        x: number;
                        y: number;
                    }>;
                    thumbHash: import("../../input/hidden").HiddenField<string>;
                }, Record<string, any>>;
            }>;
        }>;
    };
} & import("alinea/core/driver/TestDriver").TestApi & import("alinea/core").CMS;
