import "../chunks/chunk-U5RRZUYZ.js";

// src/core/Config.ts
import { CloudAuthView } from "alinea/cloud/view/CloudAuth";
import { MediaSchema } from "alinea/core/media/MediaSchema";
import { Workspace } from "./Workspace.js";
var Config;
((Config2) => {
  function mainWorkspace(config) {
    const key = Object.keys(config.workspaces)[0];
    return Workspace.data(config.workspaces[key]);
  }
  Config2.mainWorkspace = mainWorkspace;
  function type(config, name) {
    return config.schema[name];
  }
  Config2.type = type;
  function hasAuth(config) {
    return Boolean(config.dashboard?.auth);
  }
  Config2.hasAuth = hasAuth;
})(Config || (Config = {}));
function createConfig(definition) {
  return {
    ...definition,
    schema: { ...MediaSchema, ...definition.schema },
    dashboard: {
      auth: CloudAuthView,
      ...definition.dashboard
    }
  };
}
export {
  Config,
  createConfig
};
