import "../chunks/chunk-U5RRZUYZ.js";

// src/core/Root.ts
import { Meta } from "./Meta.js";
var Root;
((Root2) => {
  Root2.Data = Symbol.for("@alinea/Root.Data");
  function label(root2) {
    return root2[Root2.Data].label;
  }
  Root2.label = label;
  function data(root2) {
    return root2[Root2.Data];
  }
  Root2.data = data;
  function defaultLocale(root2) {
    return root2[Root2.Data].i18n?.locales[0];
  }
  Root2.defaultLocale = defaultLocale;
  function isRoot(value) {
    return Boolean(value && value[Root2.Data]);
  }
  Root2.isRoot = isRoot;
})(Root || (Root = {}));
function root(label, definition) {
  return {
    ...definition,
    [Root.Data]: {
      label,
      ...definition[Meta]
    }
  };
}
((root2) => {
  root2.meta = Meta;
})(root || (root = {}));
export {
  Root,
  root
};
