import { Database } from 'alinea/backend';
import { Store } from 'alinea/backend/Store';
import PLazy from 'p-lazy';
import { CMS, CMSApi } from '../CMS.js';
import { Config } from '../Config.js';
import { Resolver } from '../Resolver.js';
export declare class DefaultDriver extends CMS {
    db: PLazy<Database>;
    readStore(): Promise<Store>;
    resolver(): Promise<Resolver>;
    private createDb;
}
export declare function createCMS<Definition extends Config>(config: Definition): Definition & CMSApi;
