import { Database } from 'alinea/backend';
import { CMS, CMSApi } from '../CMS.js';
import { Config } from '../Config.js';
import { Connection } from '../Connection.js';
export interface TestApi extends CMSApi {
    db: Promise<Database>;
    connection(): Promise<Connection>;
}
export declare function createTestCMS<Definition extends Config>(config: Definition): Definition & TestApi & CMS;
