import "../../chunks/chunk-U5RRZUYZ.js";

// src/core/field/RichTextField.ts
import { RichTextShape } from "alinea/core";
import { Field } from "../Field.js";
var RichTextField = class extends Field {
  constructor(shape, meta) {
    super({
      shape: new RichTextShape(
        meta.options.label,
        shape,
        meta.options.initialValue,
        meta.options.searchable
      ),
      ...meta
    });
  }
};
export {
  RichTextField
};
