import { Field, FieldMeta, FieldOptions } from '../Field.js';
import { RecordShape } from '../shape/RecordShape.js';
import { UnionMutator, UnionRow } from '../shape/UnionShape.js';
export declare class UnionField<Row extends UnionRow, Options extends FieldOptions<Row>> extends Field<Row, UnionMutator<Row>, Options> {
    constructor(shapes: {
        [key: string]: RecordShape<any>;
    }, meta: FieldMeta<Row, UnionMutator<Row>, Options>);
}
