import "../../chunks/chunk-U5RRZUYZ.js";

// src/core/media/MediaRoot.browser.tsx
import { MediaExplorer } from "alinea/dashboard/view/MediaExplorer";
import IcRoundPermMedia from "alinea/ui/icons/IcRoundPermMedia";
import { Meta } from "../Meta.js";
import { root } from "../Root.js";
import {
  createMediaRoot as createMediaRootConfig,
  mediaRootId
} from "./MediaRoot.js";
import { isMediaRoot } from "./MediaRoot.js";
function createMediaRoot(children = {}) {
  return root("Media", {
    ...createMediaRootConfig(children),
    [Meta]: {
      icon: IcRoundPermMedia,
      contains: ["MediaLibrary"],
      view: MediaExplorer
    },
    [mediaRootId]: true
  });
}
export {
  createMediaRoot,
  isMediaRoot
};
