import { PageSeed } from '../Page.js';
import { Root } from '../Root.js';
export type MediaRoot<Children extends Record<string, PageSeed>> = Root<Children>;
export declare const mediaRootId: unique symbol;
export declare function isMediaRoot(root: any): root is MediaRoot<Record<string, PageSeed>>;
export declare function createMediaRoot<Children extends Record<string, PageSeed>>(children?: Children): MediaRoot<Children>;
