/// <reference types="react" />
import { EntryRow, Schema, View } from 'alinea/core';
import { Cursor } from 'alinea/core/pages/Cursor';
export type ExplorerRowProps = {
    schema: Schema;
    cursor: Cursor.Find<EntryRow>;
    batchSize: number;
    amount: number;
    from: number;
    summaryView: 'summaryRow' | 'summaryThumb';
    defaultView: View<EntryRow, any>;
};
export declare const ExplorerRow: import("react").NamedExoticComponent<ExplorerRowProps>;
