import "../../chunks/chunk-U5RRZUYZ.js";

// src/input/list/ListField.tsx
import { Schema } from "alinea/core";
import { ListField } from "alinea/core/field/ListField";
import { listHint } from "alinea/core/util/Hints";
function list(label, options) {
  return new ListField(Schema.shapes(options.schema), {
    hint: listHint(options.schema),
    options: { label, ...options }
  });
}
export {
  list
};
