import "../../chunks/chunk-U5RRZUYZ.js";

// src/input/select/SelectField.tsx
import { Hint } from "alinea/core/Hint";
import { ScalarField } from "alinea/core/field/ScalarField";
var SelectField = class extends ScalarField {
};
function select(label, items, options = {}) {
  const keys = Object.keys(items);
  return new SelectField({
    hint: Hint.Union(keys.map((key) => Hint.Literal(key))),
    options: {
      label,
      items,
      ...options
    }
  });
}
export {
  SelectField,
  select
};
