import { Picker } from 'alinea/core';
import { Reference } from 'alinea/core/Reference';
import { Type } from 'alinea/core/Type';
export interface UrlReference extends Reference {
    ref: 'url';
    url: string;
    title: string;
    target: string;
}
export declare namespace UrlReference {
    function isUrl(value: any): value is UrlReference;
}
export interface UrlPickerOptions<T> {
    fields?: Type<T>;
}
export declare function urlPicker<Fields>(options: UrlPickerOptions<Fields>): Picker<UrlReference & Type.Infer<Fields>>;
