export declare class DeepMap<K, V> {
    #private;
    constructor(entries?: ReadonlyArray<readonly [ReadonlyArray<K>, V]> | null);
    get size(): number;
    set(keys: ReadonlyArray<K>, value: V): this;
    clear(): void;
    delete(keys: ReadonlyArray<K>): boolean;
    has(keys: ReadonlyArray<K>): boolean;
    get(keys: ReadonlyArray<K>): V | undefined;
    values(): IterableIterator<V>;
    keys(): IterableIterator<ReadonlyArray<K>>;
    entries(): IterableIterator<[ReadonlyArray<K>, V]>;
    [Symbol.iterator](): IterableIterator<[ReadonlyArray<K>, V]>;
}
