import { History, Revision } from 'alinea/backend/History';
import { Config } from 'alinea/core';
import { EntryRecord } from 'alinea/core/EntryRecord';
import { SimpleGit } from 'simple-git';
export declare class GitHistory implements History {
    config: Config;
    rootDir: string;
    git: SimpleGit;
    constructor(config: Config, rootDir: string);
    revisions(file: string): Promise<Array<Revision>>;
    revisionData(file: string, ref: string): Promise<EntryRecord>;
}
