import { metadata } from 'alinea/input/metadata';
import { PathField } from 'alinea/input/path';
import { TextField } from 'alinea/input/text';
import { Label } from './Label.js';
import { Type, TypeDefinition } from './Type.js';
type Document<Definition> = {
    title: TextField;
    path: PathField;
    metadata: ReturnType<typeof metadata>;
} & Definition;
export declare function document<Definition extends TypeDefinition>(label: Label, definition: Definition): Type<Document<Definition>>;
export {};
