/// <reference types="react" />
import { CMSApi } from '../CMS.js';
import { Config } from '../Config.js';
export interface NextApi extends CMSApi {
    previews(): Promise<JSX.Element | null>;
    backendHandler(request: Request): Promise<Response>;
    previewHandler(request: Request): Promise<Response>;
}
export declare function createNextCMS<Definition extends Config>(config: Definition): Definition & NextApi;
