import "../../chunks/chunk-U5RRZUYZ.js";

// src/core/field/ListField.ts
import { Field } from "../Field.js";
import { ListShape } from "../shape/ListShape.js";
var ListField = class extends Field {
  constructor(shape, meta) {
    super({
      shape: new ListShape(
        meta.options.label,
        shape,
        meta.options.initialValue,
        meta.postProcess
      ),
      ...meta
    });
  }
};
export {
  ListField
};
