import "../../chunks/chunk-U5RRZUYZ.js";

// src/core/media/MediaRoot.tsx
import IcRoundPermMedia from "alinea/ui/icons/IcRoundPermMedia";
import { Meta } from "../Meta.js";
import { root } from "../Root.js";
var mediaRootId = Symbol.for("@alinea/mediaRoot");
function isMediaRoot(root2) {
  return Boolean(root2[mediaRootId]);
}
function createMediaRoot(children = {}) {
  return root("Media", {
    ...children,
    [Meta]: {
      icon: IcRoundPermMedia,
      contains: ["MediaLibrary"]
    },
    [mediaRootId]: true
  });
}
export {
  createMediaRoot,
  isMediaRoot,
  mediaRootId
};
