import { Type } from 'alinea/core/Type';
export type MediaLibrary = Type.Infer<typeof MediaLibrary>;
export declare const MediaLibrary: Type<{
    title: import("alinea/input/text").TextField;
    path: import("alinea/input/path").PathField;
}>;
export type MediaFile = Type.Infer<typeof MediaFile>;
export declare const MediaFile: Type<{
    title: import("alinea/input/text").TextField;
    path: import("alinea/input/path").PathField;
    location: import("alinea/input/hidden").HiddenField<string>;
    extension: import("alinea/input/hidden").HiddenField<string>;
    size: import("alinea/input/hidden").HiddenField<number>;
    hash: import("alinea/input/hidden").HiddenField<string>;
    width: import("alinea/input/hidden").HiddenField<number>;
    height: import("alinea/input/hidden").HiddenField<number>;
    preview: import("alinea/input/hidden").HiddenField<string>;
    averageColor: import("alinea/input/hidden").HiddenField<string>;
    focus: import("alinea/input/hidden").HiddenField<{
        x: number;
        y: number;
    }>;
    thumbHash: import("alinea/input/hidden").HiddenField<string>;
}>;
export declare const MediaSchema: {
    MediaLibrary: Type<{
        title: import("alinea/input/text").TextField;
        path: import("alinea/input/path").PathField;
    }>;
    MediaFile: Type<{
        title: import("alinea/input/text").TextField;
        path: import("alinea/input/path").PathField;
        location: import("alinea/input/hidden").HiddenField<string>;
        extension: import("alinea/input/hidden").HiddenField<string>;
        size: import("alinea/input/hidden").HiddenField<number>;
        hash: import("alinea/input/hidden").HiddenField<string>;
        width: import("alinea/input/hidden").HiddenField<number>;
        height: import("alinea/input/hidden").HiddenField<number>;
        preview: import("alinea/input/hidden").HiddenField<string>;
        averageColor: import("alinea/input/hidden").HiddenField<string>;
        focus: import("alinea/input/hidden").HiddenField<{
            x: number;
            y: number;
        }>;
        thumbHash: import("alinea/input/hidden").HiddenField<string>;
    }>;
};
