import { FieldOptions, Type, WithoutLabel } from 'alinea/core';
import { RecordField } from 'alinea/core/field/RecordField';
export interface ObjectOptions<Definition> extends FieldOptions<Type.Infer<Definition>> {
    /** The fields */
    fields: Type<Definition>;
    width?: number;
    help?: string;
    inline?: boolean;
}
export declare class ObjectField<Definition> extends RecordField<Type.Infer<Definition>, ObjectOptions<Definition>> {
}
export declare function object<Definition>(label: string, options: WithoutLabel<ObjectOptions<Definition>>): ObjectField<Definition>;
