import {
  Editor
} from "../../../chunks/chunk-OBYSELPT.js";
import "../../../chunks/chunk-I5C4WAC4.js";
import "../../../chunks/chunk-MDIOFKJQ.js";
import "../../../chunks/chunk-U5RRZUYZ.js";

// src/input/richtext/hook/UseEditor.tsx
import { useForceUpdate } from "alinea/ui/hook/UseForceUpdate";
import { useEffect, useMemo } from "react";
var useEditor = (options = {}, dependencies = []) => {
  const editor = useMemo(() => new Editor(options), []);
  const forceUpdate = useForceUpdate();
  useEffect(() => {
    editor.on("transaction", forceUpdate);
    return () => editor.destroy();
  }, [editor]);
  return editor;
};
export {
  useEditor
};
