import { Field, SectionData, SectionDefinition, Type, UnionToIntersection, type } from 'alinea/core';
export declare class TabsSection implements SectionData {
    types: Array<Type>;
    definition: SectionDefinition;
    fields: Record<string, Field>;
    constructor(types: Array<Type>);
}
type ArrayIntersection<T> = Type<UnionToIntersection<T extends Array<Type<infer V>> ? V : never>>;
/** Create tabs */
export declare function tabs<Types extends Array<Type>>(...types: Types): ArrayIntersection<Types>;
/** Create a tab */
export declare const tab: typeof type;
export {};
