import "../../chunks/chunk-U5RRZUYZ.js";

// src/picker/entry/EntryReference.ts
var EntryReference;
((EntryReference2) => {
  function isEntryReference(value) {
    return value && "entry" in value;
  }
  EntryReference2.isEntryReference = isEntryReference;
})(EntryReference || (EntryReference = {}));
var FileReference;
((FileReference2) => {
  function isFileReference(value) {
    return value && (value.type === "file" || value.ref === "file");
  }
  FileReference2.isFileReference = isFileReference;
})(FileReference || (FileReference = {}));
var ImageReference;
((ImageReference2) => {
  function isImageReference(value) {
    return value && (value.type === "image" || value.ref === "image");
  }
  ImageReference2.isImageReference = isImageReference;
})(ImageReference || (ImageReference = {}));
export {
  EntryReference,
  FileReference,
  ImageReference
};
