import "../chunks/chunk-U5RRZUYZ.js";

// src/ui/Property.module.scss
var Property_module_default = {
  "root": "alinea-Property",
  "root-label": "alinea-Property-label",
  "rootLabel": "alinea-Property-label",
  "root-contents": "alinea-Property-contents",
  "rootContents": "alinea-Property-contents"
};

// src/ui/Property.tsx
import { fromModule } from "./util/Styler.js";
import { jsx, jsxs } from "react/jsx-runtime";
var styles = fromModule(Property_module_default);
function Property({ label, children }) {
  return /* @__PURE__ */ jsxs("div", { className: styles.root(), children: [
    /* @__PURE__ */ jsx("div", { className: styles.root.label(), children: label }),
    /* @__PURE__ */ jsx("div", { className: styles.root.contents(), children })
  ] });
}
export {
  Property
};
